unit uBricks;

interface

uses
  uToy
  ;

type

  TBricks = class(TToy)
  private

    FSetNo: integer;
    FPlayDesc: string;

  protected

    function GetName: string; override;
    procedure SetSetNo(Value: integer); override;

  public

    procedure PlayWithMe; override;
    procedure TidyMeAway; override;

    property Name: string
      read GetName;

    property SetNo: integer
      write SetSetNo;

  published

  end;


implementation

uses
  sysutils
  , dialogs
  ;

{ TBricks }

function TBricks.GetName: string;
begin
  Result := 'No. ' + IntToStr(FSetNo) + ' set of bricks';
end;

procedure TBricks.PlayWithMe;
begin
  ShowMessage('Wow - you''ve built a great ' + FPlayDesc);
end;

procedure TBricks.SetSetNo(Value: integer);
begin
  case Value of
    1: FPlayDesc := 'House';
    2: FPlayDesc := 'Town';
    3: FPlayDesc := 'City';
  end;
  FSetNo := Value;
end;

procedure TBricks.TidyMeAway;
begin
  ShowMessage('Well done. You''ve put away bricks set ' + IntToStr(FSetNo));
end;

end.
