unit uToyFactory;

interface

uses
  uToy
  , classes                     // for TPersistent
  ;

type

  TToyFactory = class(TPersistent)
  private

  protected

  public

    function GetSet1: TToy; virtual; abstract;
    function GetSet2: TToy; virtual; abstract;
    function GetSet3: TToy; virtual; abstract;

  published

  end;

procedure RegisterFactory(ToyType, ClassName: string);

implementation

uses
  uToyShop
  ;

{ TToyFactory }

procedure RegisterFactory(ToyType, ClassName: string);
var
  tsTemp: TToyShop;
begin
  tsTemp := TToyShop.Create;           // Get a reference to the toy shop
  tsTemp.Register(ToyType, ClassName);
end;

end.
